//+------------------------------------------------------------------+
//|           ATR Percentage S/L-T/P .mq4
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Joshua Jones"
#property link      "http://www.forexfactory.com"

#property indicator_chart_window
#property indicator_buffers 4

//---- Input parameters
extern int periods=14;
extern double percentSL=1.5;
extern double percentTP1 = 2;
extern double percentTP2 = 3;
extern double percentTP3 = 4;
extern int corner=4;

int pipMult=10000;

//---- Indicator buffers
double buffera[];
double bufferb[];
double bufferc[];
double bufferd[];

string prefixa = "";
string prefixb = "";
string prefixc = "";
string prefixd = "";

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
  
  
  


   if(StringFind(Symbol(),"JPY",0)!=-1)
     {
      pipMult=100;
     }
     {
      int percentagea=percentSL*100;
      prefixa=percentagea+"% of ";
     }
     {
      int percentageb=percentTP1*100;
      prefixb=percentageb+"% of ";
     }
     {
      int percentagec=percentTP2*100;
      prefixc=percentagec+"% of ";
     }
     {
      int percentaged=percentTP3*100;
      prefixd=percentaged+"% of ";
     }

   IndicatorBuffers(4);
   SetIndexBuffer(0,buffera);
   SetIndexBuffer(1,bufferb);
   SetIndexBuffer(2,bufferc);
   SetIndexBuffer(3,bufferd);

   SetIndexLabel(0,"ATR ("+periods+")");
   SetIndexStyle(0,DRAW_NONE);
   IndicatorShortName(" S/T P/T ATR ("+periods+")");

//if(ObjectFind("label_ATRinPipsSL")==-1)
//if(ObjectFind("label_ATRinPipsTP1")==-1)
//if(ObjectFind("label_ATRinPipsTP2")==-1)
//if(ObjectFind("label_ATRinPipsTP3")==-1)

   ObjectCreate("label_ATRinPipsSL",OBJ_LABEL,0,0,0);
   ObjectCreate("label_ATRinPipsTP1",OBJ_LABEL,0,0,0);
   ObjectCreate("label_ATRinPipsTP2",OBJ_LABEL,0,0,0);
   ObjectCreate("label_ATRinPipsTP3",OBJ_LABEL,0,0,0);

   ObjectSet("label_ATRinPipsSL",OBJPROP_CORNER,corner);
   ObjectSet("label_ATRinPipsSL",OBJPROP_XDISTANCE,5);
   ObjectSet("label_ATRinPipsSL",OBJPROP_YDISTANCE,15);

   ObjectSet("label_ATRinPipsTP1",OBJPROP_CORNER,corner);
   ObjectSet("label_ATRinPipsTP1",OBJPROP_XDISTANCE,5);
   ObjectSet("label_ATRinPipsTP1",OBJPROP_YDISTANCE,18+10);

   ObjectSet("label_ATRinPipsTP2",OBJPROP_CORNER,corner);
   ObjectSet("label_ATRinPipsTP2",OBJPROP_XDISTANCE,5);
   ObjectSet("label_ATRinPipsTP2",OBJPROP_YDISTANCE,18+24);

   ObjectSet("label_ATRinPipsTP3",OBJPROP_CORNER,corner);
   ObjectSet("label_ATRinPipsTP3",OBJPROP_XDISTANCE,5);
   ObjectSet("label_ATRinPipsTP3",OBJPROP_YDISTANCE,18+38);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
  {

   int limit;
   int counted_bars=IndicatorCounted();

//---- Check for possible errors
   if(counted_bars<0) return(-1);

//---- Last counted bar will be recounted
   if(counted_bars>0) counted_bars--;

   limit=Bars-counted_bars;

   for(int i=0; i<limit; i++)
     {

      double stopLossa = MathCeil(pipMult * percentSL * (iATR(NULL,0,periods,i)));
      double stopLossb = MathCeil(pipMult * percentTP1 * (iATR(NULL,0,periods,i)));
      double stopLossc = MathCeil(pipMult * percentTP2 * (iATR(NULL,0,periods,i)));
      double stopLossd = MathCeil(pipMult * percentTP3 * (iATR(NULL,0,periods,i)));
      buffera[i] = stopLossa;
      bufferb[i] = stopLossb;
      bufferc[i] = stopLossc;
      bufferd[i] = stopLossd;
     }

//-----Comment(prefix, "ATR (", periods, "): ", buffer[0], " pips");
   string textb = prefixa+ "ATR ("+ periods+ ") :       S/L- "+ DoubleToStr(buffera[0],0)+" pips";
   string texta = prefixb+ "ATR ("+ periods+ ") : 1st-P/T- "+ DoubleToStr(bufferb[0],0)+" pips";
   string textc = prefixc+ "ATR ("+ periods+ ") : 2nd-P/T- "+ DoubleToStr(bufferc[0],0)+" pips";
   string textd = prefixd+ "ATR ("+ periods+ ") : 3rd-P/T- "+ DoubleToStr(bufferd[0],0)+" pips";


   ObjectSetText("label_ATRinPipsSL",textb,8,"Arial",White);
   ObjectSetText("label_ATRinPipsTP1",texta,8,"Arial",White);
   ObjectSetText("label_ATRinPipsTP2",textc,8,"Arial",White);
   ObjectSetText("label_ATRinPipsTP3",textd,8,"Arial",White);

   return(0);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   ObjectDelete("label_ATRinPipsSL");
   ObjectDelete("label_ATRinPipsTP1");
   ObjectDelete("label_ATRinPipsTP2");
   ObjectDelete("label_ATRinPipsTP3");
   return(0);
  }
//+------------------------------------------------------------------+
